from typing import Dict

from .CityClass import CityClass
from .Resource import Resource
from .ItemProperty import ItemProperty, ItemPropertyValue

CityProperties: Dict[CityClass, Dict[ItemProperty, ItemPropertyValue]] = {
    CityClass.DEFAULT: {
        ItemProperty.WALL_LEVEL: 0,
        ItemProperty.WALL_LEVEL_MAX: 2,
        ItemProperty.MERCHANT_PRODUCTION: [Resource.GOLD, Resource.GOLD],
        ItemProperty.BASE_PRODUCTION: [Resource.FOOD, Resource.FOOD, Resource.GOLD, Resource.GOLD],
        ItemProperty.GRANARY_FOOD: 0,
        ItemProperty.GRANARY_FOOD_MAX: 5,
        ItemProperty.GROWTH_POINTS: 0,
        ItemProperty.GROWTH_POINTS_RATE: 4,
        ItemProperty.GROWTH_POINTS_MIN: 1,
        ItemProperty.GROWTH_POINTS_MAX: 4,
    }
}
