from __future__ import annotations
from enum import IntEnum


class Resource(IntEnum):
    FOOD = 1
    GOLD = 2
    STONE = 3
    WOOD = 4

    @staticmethod
    def fromName(name: str) -> Resource:
        if name not in unitClassName2Id:
            raise ValueError(f"Invalid unit class name {name}")
        return unitClassName2Id[name]

    def toName(self) -> str:
        return unitClassId2Name[self]


Resources = {
    Resource.FOOD,
    Resource.GOLD,
    Resource.STONE,
    Resource.WOOD
}

unitClassId2Name = {
    Resource.FOOD: "Food",
    Resource.GOLD: "Gold",
    Resource.STONE: "Stone",
    Resource.WOOD: "Wood"
}

unitClassName2Id = {
    "Food": Resource.FOOD,
    "Gold": Resource.GOLD,
    "Stone": Resource.STONE,
    "Wood": Resource.WOOD
}
