from typing import Dict

from .UnitClass import UnitClass
from .ItemProperty import ItemProperty, ItemPropertyValue

UnitProperties: Dict[UnitClass, Dict[ItemProperty, ItemPropertyValue]] = {
    UnitClass.WORKER: {
        ItemProperty.LIFE_POINTS: 10,
        ItemProperty.MAX_LIFE_POINTS: 10,
        ItemProperty.MOVE_POINTS: 8,
        ItemProperty.MAX_MOVE_POINTS: 8,
    },
    UnitClass.FARMER: {
        ItemProperty.LIFE_POINTS: 10,
        ItemProperty.MAX_LIFE_POINTS: 10,
        ItemProperty.MOVE_POINTS: 8,
        ItemProperty.MAX_MOVE_POINTS: 8,
    },
    UnitClass.BOWMAN: {
        ItemProperty.LIFE_POINTS: 10,
        ItemProperty.MAX_LIFE_POINTS: 10,
        ItemProperty.MOVE_POINTS: 10,
        ItemProperty.MAX_MOVE_POINTS: 10,
        ItemProperty.ACTION_POINTS: 2,
        ItemProperty.MAX_ACTION_POINTS: 2,
        ItemProperty.MELEE_ATTACK: 4,
        ItemProperty.BOW_ATTACK: 5,
        ItemProperty.BOW_RANGE: 5,
        ItemProperty.MELEE_DEFENSE: 1,
        ItemProperty.BOW_DEFENSE: 3,
        ItemProperty.MOUNT_DEFENSE: 1,
        ItemProperty.SIEGE_DEFENSE: 3
    },
    UnitClass.PIKEMAN: {
        ItemProperty.LIFE_POINTS: 10,
        ItemProperty.MAX_LIFE_POINTS: 10,
        ItemProperty.MOVE_POINTS: 8,
        ItemProperty.MAX_MOVE_POINTS: 8,
        ItemProperty.ACTION_POINTS: 1,
        ItemProperty.MAX_ACTION_POINTS: 1,
        ItemProperty.MELEE_ATTACK: 6,
        ItemProperty.MELEE_DEFENSE: 2,
        ItemProperty.BOW_DEFENSE: 2,
        ItemProperty.MOUNT_DEFENSE: 8,
        ItemProperty.SIEGE_DEFENSE: 2,
    },
    UnitClass.SWORDSMAN: {
        ItemProperty.LIFE_POINTS: 10,
        ItemProperty.MAX_LIFE_POINTS: 10,
        ItemProperty.MOVE_POINTS: 6,
        ItemProperty.MAX_MOVE_POINTS: 6,
        ItemProperty.ACTION_POINTS: 1,
        ItemProperty.MAX_ACTION_POINTS: 1,
        ItemProperty.MELEE_ATTACK: 8,
        ItemProperty.MELEE_DEFENSE: 3,
        ItemProperty.BOW_DEFENSE: 3,
        ItemProperty.MOUNT_DEFENSE: 3,
        ItemProperty.SIEGE_DEFENSE: 1,
    },
    UnitClass.KNIGHT: {
        ItemProperty.LIFE_POINTS: 10,
        ItemProperty.MAX_LIFE_POINTS: 10,
        ItemProperty.MOVE_POINTS: 16,
        ItemProperty.MAX_MOVE_POINTS: 16,
        ItemProperty.ACTION_POINTS: 1,
        ItemProperty.MAX_ACTION_POINTS: 1,
        ItemProperty.MOUNT_ATTACK: 10,
        ItemProperty.MELEE_DEFENSE: 2,
        ItemProperty.BOW_DEFENSE: 2,
        ItemProperty.MOUNT_DEFENSE: 2,
        ItemProperty.SIEGE_DEFENSE: 2,
    },
    UnitClass.CATAPULT: {
        ItemProperty.LIFE_POINTS: 10,
        ItemProperty.MAX_LIFE_POINTS: 10,
        ItemProperty.MOVE_POINTS: 4,
        ItemProperty.MAX_MOVE_POINTS: 4,
        ItemProperty.ACTION_POINTS: 1,
        ItemProperty.MAX_ACTION_POINTS: 1,
        ItemProperty.SIEGE_ATTACK: 6,
        ItemProperty.SIEGE_RANGE: 5,
    }
}
