from typing import Optional, Tuple, Dict, Any

from ...IDataTransfer import IDataTransfer


class Citizen(IDataTransfer):

    __slots__ = ["__cell"]

    def __init__(self, data: Optional[Dict[str, Any]] = None):
        if data is None:
            self.__cell: Optional[Tuple[int, int]] = None
        else:
            self.takeData(data)

    @property
    def cell(self) -> Optional[Tuple[int, int]]:
        return self.__cell

    @cell.setter
    def cell(self, cell: Optional[Tuple[int, int]]):
        self.__cell = cell

    def gatherData(self) -> Dict[str, Any]:
        return {
            "cell": self.__cell
        }

    def takeData(self, data: Dict[str, Any]):
        tileData = data["cell"]
        if tileData is None:
            self.__cell = None
        else:
            self.__cell = (int(tileData[0]), int(tileData[1]))
